#define _16bit OSL_PF_8888
#define spr_draw oslDrawImageXY
#define MAXSPRITES 1024

#include <oslib/oslib.h>
#include <oslib/libpspmath/pspmath.h>
#include <psputils.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspmpeg.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <psppower.h>
#include <pspfpu.h>
#include <pspgu.h>
#include <psptypes.h>
#include "common.h"
#include "room.h"
#include "quicksort.h"
#include "define_room.h"
#include "sprite_struct.h"
#include <stdio.h>
#include <stdlib.h>

SceKernelUtilsMt19937Context ctx;
OSL_FONT *fonts[3];

int exit_callback(int arg1, int arg2, void *common) {
          sceKernelExitGame();
          return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp) {
          int cbid;

          cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
          sceKernelRegisterExitCallback(cbid);

          sceKernelSleepThreadCB();

          return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void) {
          int thid = 0;

          thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
          if(thid >= 0) {
                    sceKernelStartThread(thid, 0, 0);
          }

          return thid;
}
// End Callback functs

void frame_debug(int frame)
{
	char buffer[20];
	OSL_FONT *oldFont = osl_curFont;
	oslSetFont(fonts[0]);

	oslSetTextColor(RGB(128, 128, 0));

	sprintf(buffer,"%d FPS",frame);

	oslDrawString(0, 0, buffer);
	oslSetFont(oldFont);
}

int random(int max)
{
	   u32 rand_val = sceKernelUtilsMt19937UInt(&ctx);
	   rand_val = rand_val % (max);
	   return (int)rand_val;
}


void zx_init()
{
	oslInit(0);
    oslInitGfx(_16bit, 1);
    oslInitAudio();
    oslInitAudioME(OSL_FMT_ALL);

	oslSetTransparentColor(RGB(255,0,255));
	oslSetBkColor(RGB(255,0,255));

    fonts[0] = oslLoadFontFile("gfx/nokia.oft");
    fonts[1] = oslLoadFontFile("gfx/amstrad.oft");
    fonts[2] = oslLoadFontFile("gfx/gothic.oft");

    oslSetFont(fonts[1]);
}

void zx_quit()
{
    oslDeinitAudio();
    oslEndGfx();
    oslQuit();
}

void setFont(int f)
{
	oslSetFont(fonts[f]);
}

void center(int y, const char *text, short font, int color)
{
	int k;
	OSL_FONT *oldFont = osl_curFont;

	oslSetFont(fonts[font]);
	oslSetTextColor(color);
	k = oslGetStringWidth(text);
	oslDrawString((480 - k)/2, y, text);
	oslSetFont(oldFont);
}
