#include <oslib/oslib.h>
#include <oslib/libpspmath/pspmath.h>
#include <psputils.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspmpeg.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <psppower.h>
#include <pspfpu.h>
#include <pspgu.h>
#include <psptypes.h>
#include "common.h"
#include "room.h"
#include "quicksort.h"
#include "define_room.h"
#include <stdio.h>
#include <stdlib.h>

void setColors()
{
	int levelno;

	SceUID checkfile;
	char path_buffer[50];

	OSL_COLOR colors[3];

	for (levelno=0; levelno<25; levelno++)
	{
		sprintf(path_buffer, "./room/cols%d.qfpc", levelno);
		checkfile = sceIoOpen(path_buffer, PSP_O_WRONLY|PSP_O_CREAT, 0777);

		  colors[0] = RGB(random(224)+31, random(224)+31, random(224)+31);
		  colors[1] = RGB(random(224)+31, random(224)+31, random(224)+31);
		  colors[2] = RGB(random(224)+31, random(224)+31, random(224)+31);

		sceIoWrite(checkfile, colors, sizeof(colors));
		sceIoClose(checkfile);
	}
}

int *generate_room()
{
	static int room[100];
	int i;

	for(i=0; i<100; i++)
	{
		room[i]=random(4)+1;
		if (i<10) room[i]=0;
		if (i>89) room[i]=0;
		if (!(i%10)) room[i]=0;
		if ((i%10) == 9) room[i]=0;
	}

	return room;
}
