#define _16bit OSL_PF_8888
#define spr_draw oslDrawImageXY
#define MAXSPRITES 1024

#include <oslib/oslib.h>
#include <oslib/libpspmath/pspmath.h>
#include <psputils.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspmpeg.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <psppower.h>
#include <pspfpu.h>
#include <pspgu.h>
#include <psptypes.h>
#include "common.h"
#include "room.h"
#include "quicksort.h"
#include "define_room.h"
#include "sprite_struct.h"
#include <stdio.h>
#include <stdlib.h>

void siftDown(int* a, float* dist, int start, int end)
{
    int root = start, t;
    int tempvarF;

		while ( root*2+1 < end ) {
			int child = 2*root + 1;
			if ((child + 1 < end) && (dist[child] < dist[child+1])) {
				child += 1;
			}
			if ((dist[root] < dist[child])) {
				t = a[child];
				a[child] = a[root];
				a[root] = t;

				tempvarF=dist[child];
				dist[child]=dist[root];
				dist[root]=tempvarF;

				root = child;
			}
			else
				return;
		}
}

void heapSort(int* a, float* dist, int count)
{
    int start, end;
    int t;
    float tempvarF;

    /* heapify */
    for (start = (count-2)/2; start >=0; start--) {
        siftDown(a, dist, start, count);
    }

    for (end=count-1; end > 0; end--) {
        t = a[end];
        a[end] = a[0];
        a[0] = t;

		tempvarF=dist[end];
		dist[end]=dist[0];
		dist[0]=tempvarF;

        siftDown(a, dist, 0, end);
    }
}

void quickSort0(int* order, float* dist, int debut, int fin)
{
    int gauche = debut-1;
    int droite = fin+1;
    int t;
    float pivot = dist[debut];
    int tempvarF;
    short endofsort=0;

    /* Si le tableau est de longueur nulle, il n'y a rien  faire. */
    if(debut >= fin)
        return;

    /* Sinon, on parcourt le tableau, une fois de droite  gauche, et une
       autre de gauche  droite,  la recherche d'lments mal placs,
       que l'on permute. Si les deux parcours se croisent, on arrte. */
    while(!endofsort)
    {
    	endofsort=0;
        do droite--; while((dist[droite] < pivot) && (droite >= debut));
        do gauche++; while(dist[gauche] > pivot);

        if(gauche < droite)
        {
            t = order[gauche];
            order[gauche] = order[droite];
            order[droite] = t;

    		tempvarF=dist[gauche];
    		dist[gauche]=dist[droite];
    		dist[droite]=tempvarF;
        }
        else endofsort=1;
    }

    /* Maintenant, tous les lments infrieurs au pivot sont avant ceux
       suprieurs au pivot. On a donc deux groupes de cases  trier. On utilise
       pour cela... la mthode quickSort elle-mme ! */
    quickSort0(order, dist, debut, droite);
    quickSort0(order, dist, droite+1, fin);
}
