#define _16bit OSL_PF_8888
#define spr_draw oslDrawImageXY
#define MAXSPRITES 1024

#include <oslib/oslib.h>
#include <oslib/libpspmath/pspmath.h>
#include <psputils.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspmpeg.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <psppower.h>
#include <pspfpu.h>
#include <pspgu.h>
#include <psptypes.h>
#include "common.h"
#include "room.h"
#include "quicksort.h"
#include "define_room.h"
#include "sprite_struct.h"
#include <stdio.h>
#include <stdlib.h>

extern OSL_IMAGE *grounds[4];

void draw_actor(OSL_IMAGE *roburi, OSL_COLOR tint, int robx, int roby, short walking, short facing)
{
	oslSetAlpha(OSL_FX_TINT, tint);
	//oslSetImageTileSize(roburi, 0, 0, roburi->sizeX, roburi->sizeY);
	spr_draw(roburi, robx, roby);
}

void draw_roburi(OSL_IMAGE *roburi, OSL_COLOR tint, int robx, int roby, short walking, short facing, unsigned long int counter)
{
	oslSetAlpha(OSL_FX_TINT, tint);
	oslSetImageTileSize(roburi, walking*24, facing*32, 24, 32);
	roburi->centerX = 12;
	roburi->centerY = 24;
	spr_draw(roburi, robx, roby);
}

void draw_room_door_bg(OSL_IMAGE *doorw, OSL_IMAGE *doore, OSL_COLOR rdc, int *nesw)
{
	int i=0, x3d=104, y3d=90;

	for(i=0; i<8; i++)
	{
		oslSetAlpha(OSL_FX_TINT, rdc);
		if ((i == 3) && (nesw[3])) spr_draw(doorw, x3d, y3d);
		x3d+=16;
		if (i < 7) y3d-=8;
	}

	x3d+=8;
	y3d+=8;

	for(i=0; i<8; i++)
	{
		oslSetAlpha(OSL_FX_TINT, rdc);
		if ((i == 3) && (nesw[0])) spr_draw(doore, x3d, y3d);
		x3d+=16;
		y3d+=8;
	}

}


void draw_room_door_fg(OSL_IMAGE *doorw, OSL_IMAGE *doore, OSL_COLOR rdc, int *nesw)
{
	oslSetAlpha(OSL_FX_TINT, rdc);

	if (nesw[1]) spr_draw(doorw, 288, 136);
	if (nesw[2]) spr_draw(doore, 152, 136);

	oslSetAlpha(OSL_FX_DEFAULT, 0);
}


void draw_room_wall(OSL_IMAGE *wallw, OSL_IMAGE *walle, OSL_COLOR rdc, int *nesw)
{
	int i=0, x3d=112, y3d=96;

	for(i=0; i<8; i++)
	{
		oslSetAlpha(OSL_FX_TINT, rdc);
		if (nesw[3])
		{
			if ((i != 3) && (i != 4)) spr_draw(wallw, x3d, y3d);
		}
		else
		{
			spr_draw(wallw, x3d, y3d);
		}
		x3d+=16;
		if (i < 7) y3d-=8;
	}

	for(i=0; i<8; i++)
	{
		oslSetAlpha(OSL_FX_TINT, rdc);
		if (nesw[0])
		{
			if ((i != 3) && (i != 4)) spr_draw(walle, x3d, y3d);
		}
		else
		{
			spr_draw(walle, x3d, y3d);
		}
		x3d+=16;
		y3d+=8;
	}

}

void draw_room_ground(int *room, OSL_COLOR rdc)
{
	int i=0, x3d=240, y3d=64;
	int x3do, y3do;
	OSL_COLOR col=rdc;

	x3do = x3d;
	y3do = y3d;

	for (i=0; i<100; i++)
	{
		if (!(i%10))
		{
			x3do-=16;
			x3d=x3do;
			y3do+=8;
			y3d=y3do;
		}
		else
		{
			x3d+=16;
			y3d+=8;
		}

	switch(*(room+i))
	{
		case 1:
		case 4:
		case 5:
		case 6:
		case 7:
			rdc=col;
			break;

		case 2: rdc=RGB(0, 255, 255); break;
		case 3: rdc=RGB(255, 0, 0); break;

		default: rdc=RGB(255,255,255); break;
	}
		oslSetAlpha(OSL_FX_TINT, rdc);
		spr_draw(grounds[*(room+i)], x3d, y3d);

	}
}

